#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityMayDayLuckDrawCFG.h"
std::auto_ptr<M_ActivityMayDayLuckDrawCFG> M_ActivityMayDayLuckDrawCFG::msSingleton(nullptr);

int M_ActivityMayDayLuckDrawCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityMayDayLuckDrawCFGData* M_ActivityMayDayLuckDrawCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityMayDayLuckDrawCFGData>& M_ActivityMayDayLuckDrawCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityMayDayLuckDrawCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityMayDayLuckDrawCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityMayDayLuckDrawCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRaffleConsumption1 = element->IntAttribute("RaffleConsumption1");
		data.mRaffleConsumption2 = element->IntAttribute("RaffleConsumption2");
		data.mBottomGuard1 = element->IntAttribute("BottomGuard1");
		data.mBottomGuard2 = element->IntAttribute("BottomGuard2");
		data.mConsumeID = element->IntAttribute("ConsumeID");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityMayDayLuckDrawCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMayDayLuckDrawCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityMayDayLuckDrawCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityMayDayLuckDrawCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityMayDayLuckDrawCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RaffleConsumption1", data.mRaffleConsumption1);
		LuaCfgHelper::readInt(L, "RaffleConsumption2", data.mRaffleConsumption2);
		LuaCfgHelper::readInt(L, "BottomGuard1", data.mBottomGuard1);
		LuaCfgHelper::readInt(L, "BottomGuard2", data.mBottomGuard2);
		LuaCfgHelper::readInt(L, "ConsumeID", data.mConsumeID);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityMayDayLuckDrawCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMayDayLuckDrawCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityMayDayLuckDrawCFG* M_ActivityMayDayLuckDrawCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityMayDayLuckDrawCFG());
	}
	return msSingleton.get();
}

void M_ActivityMayDayLuckDrawCFG::Release()
{
	msSingleton.reset(nullptr);
}
